<script lang="ts">
import { defineComponent, computed, ref } from 'vue';
import JSpinner from '@new-jira-clone/ui/src/components/loaders/JSpinner';

const sizesMap: { [key: string]: string } = {
  custom: 'size-custom',
  m: 'text-subtitle-3 size-m',
  s: 'text-subtitle-5 size-s',
  xs: 'text-body-4 size-xs',
  xxs: 'text-body-4 size-xxs',
};

export const sizesConfig = ['custom', 'm', 's', 'xs', 'xxs'];
export const typesConfig = ['primary', 'stroked', 'flat', 'outlined'];
export const colorsConfig = ['primary', 'red', 'white', 'gray'];

export default defineComponent({
  name: 'JButton',
  components: {
    JSpinner,
  },
  props: {
    size: {
      type: String,
      default: 'xxs',
      validator: (value: string): boolean => sizesConfig.includes(value),
    },
    type: {
      type: String,
      default: 'primary',
      validator: (value: string): boolean => typesConfig.includes(value),
    },
    color: {
      type: String,
      default: 'primary',
      validator: (value: string): boolean => colorsConfig.includes(value),
    },
    loading: {
      type: Boolean,
      default: false,
    },
    icon: {
      type: Boolean,
      default: false,
    },
  },
  setup(props) {
    const btnSize = computed((): string => sizesMap[props.size]);

    const uiButtonRef = ref<HTMLElement | null>(null);

    return { btnSize, uiButtonRef };
  },
});
</script>

<template>
  <button
    ref="uiButtonRef"
    v-ripple
    :bind="{ ...$attrs }"
    class="j-button"
    :class="[btnSize, type, { 'j-btn-icon': icon }, `${color}-color`]"
  >
    <span class="j-button-bg" />
    <div class="j-button-label">
      <JSpinner
        v-if="loading"
        width="20px"
        height="20px"
      />
      <slot v-else />
    </div>
  </button>
</template>

<style lang="scss" scoped>
@use '../../../styles/tools/mixins' as mixins;
@import './_variables.scss';

.j-button.size-xxs {
  padding: map-get($btn-paddings, "xxs");
  height: map-get($btn-heights, "xxs");
}

.j-button.size-xs {
  padding: map-get($btn-paddings, "xs");
  height: map-get($btn-heights, "xs");
}

.j-button.size-s {
  padding: map-get($btn-paddings, "s");
  height: map-get($btn-heights, "s");
}

.j-button.size-m {
  padding: map-get($btn-paddings, "m");
  height: map-get($btn-heights, "m");
}

.j-button.size-custom {
  height: map-get($btn-heights, "m");
}

.j-button-bg {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  pointer-events: none;
  border-radius: inherit;
}

.j-button {
  display: flex;
  align-items: center;
  justify-content: center;
  position: relative;
  overflow: hidden;
  cursor: pointer;
  border-radius: 4px;
  border: unset;
  font-weight: 500;
  transition: background 200ms, border 200ms;

  &::after {
    content: '';
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    pointer-events: none;
    border: 2px solid currentColor;
    border-radius: inherit;
    opacity: 0;
    transition: opacity .2s ease-in-out;
  }

  &:focus-visible {
    outline: none;

    &::after {
      opacity: 0.24;
    }

    .j-button-bg {
      opacity: 0.7;
    }
  }

  &:hover {
    :deep(.j-icon) {
      &[with-hover] {
        use[default] {
          display: none;
        }

        use[hover] {
          display: initial;
        }
      }
    }
  }

  &:not(&.flat, &.outlined) {
    box-shadow: 0 3px 1px -2px #0003, 0 2px 2px #00000024, 0 1px 5px #0000001f;
  }

  &.stroked {
    border: 1px rgb(var(--j-primary-text-color)) solid;

    &:hover {
      .j-button-bg {
        opacity: 0.9;
      }
    }
  }

  &.white-color {
    color: var(--j-text);
    background-color: rgb(var(--j-primary-text-color));

    &:hover {
      .j-button-bg {
        background-color: var(--j-primary-hover-color);
        opacity: 1;
      }
    }

    .j-spinner {
      color: var(--j-text);
    }
  }

  &.primary-color {
    &:hover {
      .j-button-bg {
        opacity: 0.8;
      }
    }

    .j-button-label, .j-spinner {
      z-index: 0;
      color: rgb(var(--j-primary-text-color));
    }

    .j-button-bg {
      background-color: rgb(var(--j-primary-color));
    }
  }

  &.red-color {
    color: var(--j-text);

    &:hover {
      .j-button-bg {
        opacity: 0.8;
      }
    }

    .j-button-label, .j-spinner {
      z-index: 0;
      color: rgb(var(--j-primary-text-color));
    }

    .j-button-bg {
      background-color: rgb(var(--j-error-color));
    }
  }

  &.outlined {
    border: 1px currentColor solid;

    &:hover {
      .j-button-bg {
        opacity: 0.04;
        background-color: currentColor;
      }
    }

    &.primary-color {
      color: rgb(var(--j-primary-color));

      .j-button-label {
        color: currentColor;
      }
    }

    &.red-color {
      color: rgb(var(--j-error-color));
    }

    .j-button-bg {
      background-color: #fff;
    }

    .j-spinner, .j-button-label {
      color: currentColor;
    }

    &.gray-color {
      fill: rgb(var(--j-secondary-title-color));
      // TODO: add to varibles
      border: 1px solid #d1d1d1;
    }
  }
}

.j-btn-icon {
  border-radius: 50%;

  &.size-xxs {
    width: calc(map-get($btn-icons, 'xxs'));
    height: calc(map-get($btn-icons, 'xxs'));
  }

  &.size-xs {
    width: calc(map-get($btn-icons, 'xs'));
    height: calc(map-get($btn-icons, 'xs'));
  }

  &.size-s {
    width: calc(map-get($btn-icons, 's'));
    height: calc(map-get($btn-icons, 's'));
  }

  &.size-m {
    width: calc(map-get($btn-icons, 'm'));
    height: calc(map-get($btn-icons, 'm'));
  }

  &.j-button {
    padding: 0;
  }

  .j-button-label {
    display: flex;
  }

  :deep(.j-icon) {
    z-index: 1;
  }
}
</style>
